/* -*- C -*-
 * File: "/home/arn/proj/cms1/db/row_acl/row_acl_binio.c"
 * Author: "Anton Yabchinskiy, <arn@antora.ru>"
 * Copyright: ""
 * Created: "Wed, 11 Jul 2007 16:02:14 +0400 (arn@doriath.my.domain)"
 * Last modified: "Tue, 17 Jul 2007 15:47:10 +0400 (arn@doriath.my.domain)"
 * vim:set sts=4 ts=4 sw=4 ft=c:
 * $Id: row_acl_binio.c,v 1.2 2007/07/17 11:43:59 anton Exp $
 */

#include <postgres.h>
#include <fmgr.h>
#include <libpq/pqformat.h>

#include "row_acl.h"

/*
 * pg infos
 */
PG_FUNCTION_INFO_V1(row_acl_receive);
PG_FUNCTION_INFO_V1(row_acl_send);

/*
 * prototypes
 */
Datum row_acl_receive(PG_FUNCTION_ARGS);
Datum row_acl_send(PG_FUNCTION_ARGS);

/* @param internal
 * @return row_acl */
Datum
row_acl_receive(PG_FUNCTION_ARGS)
{
    StringInfo  buf;

    buf = (StringInfo)PG_GETARG_POINTER(0);

    ROW_ACL_RETURN(pq_getmsgint(buf, sizeof(row_acl)));
}

/* @param row_acl
 * @return bytea */
Datum
row_acl_send(PG_FUNCTION_ARGS)
{
    StringInfoData  buf;

    pq_begintypsend(&buf);
    pq_sendint(&buf, ROW_ACL_GETARG(0), sizeof(row_acl));

    PG_RETURN_BYTEA_P(pq_endtypsend(&buf));
}
