/* -*- C -*-
 * File: "/home/arn/proj/cms1/db/row_acl/row_acl_bits.h"
 * Author: "Anton Yabchinskiy, <arn@antora.ru>"
 * Copyright: ""
 * Created: "Thu, 12 Jul 2007 10:17:24 +0400 (arn@doriath.my.domain)"
 * Last modified: "Tue, 17 Jul 2007 14:36:34 +0400 (arn@doriath.my.domain)"
 * vim:set sts=4 ts=4 sw=4 ft=c:
 * $Id: row_acl_bits.h,v 1.1 2007/07/17 10:59:22 anton Exp $
 */

#ifndef __ROW_ACL_BITS_H_INCLUDED__
#define __ROW_ACL_BITS_H_INCLUDED__	1

#include "row_acl.h"

static inline int
row_acl_count_ones(row_acl p_acl)
{
    p_acl = (p_acl & 0x5555) + ((p_acl >> 1) & 0x5555);
    p_acl = (p_acl & 0x3333) + ((p_acl >> 2) & 0x3333);
    p_acl = (p_acl & 0x0f0f) + ((p_acl >> 4) & 0x0f0f);

    return (p_acl & 0x00ff) + (p_acl >> 8);
}

static inline int
uint8_count_ones(uint8 p_bits)
{
    p_bits = (p_bits & 0x55) + ((p_bits >> 1) & 0x55);
    p_bits = (p_bits & 0x33) + ((p_bits >> 2) & 0x33);

    return (p_bits & 0x0f) + (p_bits >> 4);
}

static inline int
uint32_count_ones(uint32 p_bits)
{
    p_bits = (p_bits & 0x55555555) + ((p_bits >> 1) & 0x55555555);
    p_bits = (p_bits & 0x33333333) + ((p_bits >> 2) & 0x33333333);
    p_bits = (p_bits & 0x0f0f0f0f) + ((p_bits >> 4) & 0x0f0f0f0f);
    p_bits = (p_bits & 0x00ff00ff) + ((p_bits >> 8) & 0x00ff00ff);

    return (p_bits & 0x0000ffff) + (p_bits >> 16);
}

#endif/* ? __ROW_ACL_BITS_H_INCLUDED__ */

