/* -*- C -*-
 * File: "/home/arn/proj/row_acl/new/row_acl_debug.h"
 * Author: "Anton Yabchinskiy, <arn@antora.ru>"
 * Copyright: ""
 * Created: "Thu, 12 Jul 2007 09:46:55 +0400 (arn@doriath.my.domain)"
 * Last modified: "Sun, 15 Jul 2007 12:54:06 +0400 (arn@mithlonde.my.domain)"
 * vim:set sts=4 ts=4 sw=4 ft=c:
 * $Id: row_acl_debug.h,v 1.1 2007/07/17 10:59:22 anton Exp $
 */

#ifndef __ROW_ACL_ROW_ACL_DEBUG_H_INCLUDED__
#define __ROW_ACL_ROW_ACL_DEBUG_H_INCLUDED__	1

#if (_ROW_ACL_ENABLE_DEBUG != 0)

#define ROW_ACL_DEBUG_PRINT(_p_format, ...)    \
    do {\
        /* has level INFO to assure what client will always see it */\
        ereport(INFO, (errcode(ERRCODE_SUCCESSFUL_COMPLETION),\
            errmsg("[d] %s:%i,%s() -- " _p_format, __FILE__, __LINE__, \
            __FUNCTION__, ##__VA_ARGS__)));\
    } while(0)

#define ROW_ACL_DEBUG_BLOCK(...)    \
    do {\
        __VA_ARGS__\
    } while(0)

#else/* ! (_ROW_ACL_ENABLE_DEBUG != 0) */

#define ROW_ACL_DEBUG_PRINT(_p_format, ...) \
    do {} while(0)

#define ROW_ACL_DEBUG_BLOCK(...)    \
    do {} while(0)

#endif/* ? (_ROW_ACL_ENABLE_DEBUG != 0) */

#endif/* ? __ROW_ACL_ROW_ACL_DEBUG_H_INCLUDED__ */

