/* -*- C -*-
 * File: "/home/arn/proj/cms1/db/row_acl/row_acl_field.h"
 * Author: "Anton Yabchinskiy, <arn@antora.ru>"
 * Copyright: ""
 * Created: "Thu, 12 Jul 2007 11:23:13 +0400 (arn@doriath.my.domain)"
 * Last modified: "Tue, 17 Jul 2007 14:39:55 +0400 (arn@doriath.my.domain)"
 * vim:set sts=4 ts=4 sw=4 ft=c:
 * $Id: row_acl_field.h,v 1.1 2007/07/17 10:59:22 anton Exp $
 */

#ifndef __ROW_ACL_ROW_ACL_FIELD_H_INCLUDED__
#define __ROW_ACL_ROW_ACL_FIELD_H_INCLUDED__    1

/*
 * distinct field type to track distincts
 * in VACUUM ANALYZE
 */

#include "row_acl.h"
#include "row_acl_bits.h"

/* TODO: use uint32 for field base */
typedef uint8   row_acl_field_t[ROW_ACL_TOTAL_COUNT / 8];
typedef uint8*  row_acl_field_p;

/* @param field field to read acl from
 * @param acl acl to read
 * @return 0 if specified acl not present in field, !0 otherwise */
static inline int
row_acl_field_get(const row_acl_field_t p_fld, row_acl p_acl)
{
    return p_fld[(p_acl & ROW_ACL_ALL) >> 3] & (0x1 << (p_acl & 0x7));
}

/* @param field field to modify
 * @param acl acl to insert into the field */
static inline void
row_acl_field_set(row_acl_field_t p_fld, row_acl p_acl)
{
    p_fld[(p_acl & ROW_ACL_ALL) >> 3] |=  (0x1 << (p_acl & 0x7));
}

/* @param field field to modify
 * @param acl acl to delete from field */
static inline void
row_acl_field_unset(row_acl_field_t p_fld, row_acl p_acl)
{
    p_fld[(p_acl & ROW_ACL_ALL) >> 3] &= ~(0x1 << (p_acl & 0x7));
}

/* @param field field to read info from
 * @return number of unique ACLs in specified field */
static inline int
row_acl_field_uniqs(const row_acl_field_t p_fld)
{
    int i;
    int r;

    for(i = 0, r = 0; i < sizeof(row_acl_field_t); ++i){
        r += uint8_count_ones(p_fld[i]);
    };

    return r;
}

#endif/* ? __ROW_ACL_ROW_ACL_FIELD_H_INCLUDED__ */

