#!/usr/bin/perl
# File: "/home/arn/proj/cms1/db/row_acl/row_acl_mktest.pl"
# Author: "Anton Yabchinskiy, <arn@antora.ru>"
# Copyright: ""
# Created: "Wed, 11 Jul 2007 14:41:16 +0400 (arn@doriath.my.domain)"
# Last modified: "Tue, 17 Jul 2007 14:51:07 +0400 (arn@doriath.my.domain)"
# vim:set sts=4 ts=4 sw=4 ft=perl:
# $Id: row_acl_mktest.pl,v 1.1 2007/07/17 10:59:22 anton Exp $

use strict;
use warnings;

my $count = $ARGV[0];
my $stats = defined $ARGV[1] ? $ARGV[1] : $count;

my $table = 'row_acl_test';
my $attrb = 'access';

my %usr_freqs = (r => 0.90, w => 0.90, d => 0.80, i => 0.80, x => 0.50);
my %grp_freqs = (r => 0.75, w => 0.64, d => 0.30, i => 0.30, x => 0.20);
my %oth_freqs = (r => 0.10, w => 0.01, d => 0.01, i => 0.01, x => 0.01);

die("usage: $0 rows_count [statistics]") unless defined $count;

print("
-- count $count
-- stats $stats
-- table $table
-- attrb $attrb
-- usr_freqs $usr_freqs{r}, $usr_freqs{w}, $usr_freqs{d}, $usr_freqs{i}, $usr_freqs{x}
-- grp_freqs $grp_freqs{r}, $grp_freqs{w}, $grp_freqs{d}, $grp_freqs{i}, $grp_freqs{x}
-- oth_freqs $oth_freqs{r}, $oth_freqs{w}, $oth_freqs{d}, $oth_freqs{i}, $oth_freqs{x}

DROP TABLE $table CASCADE;

CREATE TABLE $table ($attrb row_acl);
ALTER TABLE $table ALTER COLUMN $attrb SET STATISTICS $stats;

");

sub random_row_acl {
    return  ('-', 'r')[rand(1) + $usr_freqs{r}] .
            ('-', 'w')[rand(1) + $usr_freqs{w}] .
            ('-', 'd')[rand(1) + $usr_freqs{d}] .
            ('-', 'i')[rand(1) + $usr_freqs{i}] .
            ('-', 'x')[rand(1) + $usr_freqs{x}] .

            ('-', 'r')[rand(1) + $grp_freqs{r}] .
            ('-', 'w')[rand(1) + $grp_freqs{w}] .
            ('-', 'd')[rand(1) + $grp_freqs{d}] .
            ('-', 'i')[rand(1) + $grp_freqs{i}] .
            ('-', 'x')[rand(1) + $grp_freqs{x}] .

            ('-', 'r')[rand(1) + $oth_freqs{r}] .
            ('-', 'w')[rand(1) + $oth_freqs{w}] .
            ('-', 'd')[rand(1) + $oth_freqs{d}] .
            ('-', 'i')[rand(1) + $oth_freqs{i}] .
            ('-', 'x')[rand(1) + $oth_freqs{x}];
}

for(; $count > 0; --$count){
    print("INSERT INTO $table ($attrb) VALUES ('" . random_row_acl() . "');\n");
};
