/* -*- C -*-
 * File: "/home/arn/proj/cms1/db/row_acl/row_acl_stats.h"
 * Author: "Anton Yabchinskiy, <arn@antora.ru>"
 * Copyright: ""
 * Created: "Fri, 13 Jul 2007 12:06:52 +0400 (arn@doriath.my.domain)"
 * Last modified: "Tue, 17 Jul 2007 14:40:58 +0400 (arn@doriath.my.domain)"
 * vim:set sts=4 ts=4 sw=4 ft=c:
 * $Id: row_acl_stats.h,v 1.1 2007/07/17 10:59:22 anton Exp $
 */

#ifndef __ROW_ACL_ROW_ACL_STATS_H_INCLUDED__
#define __ROW_ACL_ROW_ACL_STATS_H_INCLUDED__	1

#include "row_acl.h"

#define ROW_ACL_STATISTICS_KIND 12345

typedef float4  row_acl_freqs_t[ROW_ACL_BIT_LENGTH];
typedef float4* row_acl_freqs_p;

static inline void
row_acl_freqs_update(row_acl_freqs_t p_freqs, row_acl p_acl)
{
    int i;

    for(i = 0; i < ROW_ACL_BIT_LENGTH; ++i){
        if((p_acl >> i) & 1){
            ++p_freqs[i];
        };
    };
}

static inline float4
row_acl_freqs_intersection(const row_acl_freqs_t p_freqs, row_acl p_acl)
{
    int     i;
    float4  s = 0;

    for(i = 0; i < ROW_ACL_BIT_LENGTH; ++i){
        if((p_acl >> i) & 1){
            s += p_freqs[i];
        };
    };

    return (s < 0) ? 0 : ((s > 1) ? 1 : s);
}

/*
static inline float4
row_acl_stats_containment(const row_acl_freqs_t p_freqs, row_acl p_acl)
{
    int     i;
    int     n = 0;
    float4  s = 0;

    for(i = 0; i < ROW_ACL_BIT_LENGTH; ++i){
        if((p_acl >> i) & 1){
            s += p_freqs[i], ++n;
        };
    };

    if(n > 0){
        s /= n;
    };

    return (s < 0) ? 0 : ((s > 1) ? 1 : s);
}
*/

static inline void
row_acl_freqs_normalise(row_acl_freqs_t p_freqs, float4 p_rows)
{
    if(p_rows > 0){
        int i;

        for(i = 0; i < ROW_ACL_BIT_LENGTH; ++i){
            p_freqs[i] /= p_rows;
        };
    };
}

#endif/* ? __ROW_ACL_ROW_ACL_STATS_H_INCLUDED__ */

